// keresoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "kereso.h"
#include "keresoDlg.h"
#define SCL 18
#define WI 320
#define HE 240

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeresoDlg dialog

const CString endl=(CString)(char)13+(CString)(char)10;

int d_s=5;
/*const int d_m[3][3]={	{1,1,1},
						{1,2,1},
						{1,1,1}};*/

const int d_m[5][5]={	{0,1,1,1,0},
						{1,2,3,2,1},
						{1,3,4,3,1},
						{1,2,3,2,1},
						{0,1,1,1,0}};

/*const int d_m[7][7]={	{0,0,1,1,1,0,0},
						{0,1,1,2,1,1,0},
						{1,1,2,3,2,1,1},
						{1,2,3,4,3,2,1},
						{1,1,2,3,2,1,1},
						{0,1,1,2,1,1,0},
						{0,0,1,1,1,0,0}};*/

CKeresoDlg::CKeresoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeresoDlg::IDD, pParent)
{
//	fil.Open("c:\\p.txt",CFile::modeCreate|CFile::modeWrite);
	//{{AFX_DATA_INIT(CKeresoDlg)
	m_Minta = -1;
	m_log = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	keres=new CPoint[3];
	DCOLOR=new long[3];
	turn_val=1;
//	map=0;
}

void CKeresoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeresoDlg)
	DDX_Control(pDX, IDC_VIDEOPORTAL1, m_cVideo);
	DDX_Radio(pDX, IDC_RADIO1, m_Minta);
	DDX_Text(pDX, IDC_LOG, m_log);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeresoDlg, CDialog)
	//{{AFX_MSG_MAP(CKeresoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_MOVECAL, OnMovecal)
	ON_BN_CLICKED(IDC_POS, OnPos)
	ON_BN_CLICKED(IDC_MOVECAL2, OnKeziKalib)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeresoDlg message handlers

BOOL CKeresoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// TODO: Add extra initialization here
	try
	{
		LEGOVPBrickLib::IVPBrickPtr pVPB(__uuidof(LEGOVPBrickLib::VPBrick));
		//m_pVPBrick->		IVPBrickPtr(__uuidof(LEGOVPBrickLib::VPBrick));
		m_pVPBrick = pVPB;
	//	m_pVPBrick->BrickTxRange = LEGOVPBrickLib::MediumRange;
	//	m_pVPBrick->PortTxRange = LEGOVPBrickLib::LongRange;

		BSTR bstrPort = NULL;
		m_pVPBrick->FindPort(&bstrPort);
		m_pVPBrick->Open(bstrPort);
		SysFreeString(bstrPort);

	}
	catch (const _com_error e)
	{
		AddLog("Error:"+(CString)(LPCSTR)e.Description());
	}
//	OnResetmap();

	char sReg[] = "HKEY_LOCAL_MACHINE\\Software\\MyApp";
	m_cVideo.PrepareControl("MyApp1", sReg, 0 );
	m_cVideo.EnableUIElements(UIELEMENT_STATUSBAR,0,TRUE);
	m_cVideo.ConnectCamera2();
	m_cVideo.SetEnablePreview(TRUE);	
	DCOLOR[0]=DCOLOR[1]=DCOLOR[2]=0;
	m_Minta=0;

	FILE *f;
	unsigned char a;
	f=fopen("camerasett.dat","rb");
	if (f!=NULL) 
		{
		a=fgetc(f);
		m_cVideo.SetCameraPropertyLong(PROPERTY_BRIGHTNESS,a);
		a=fgetc(f);
		m_cVideo.SetCameraPropertyLong(PROPERTY_CONTRAST,a);
		a=fgetc(f);
		m_cVideo.SetCameraPropertyLong(PROPERTY_SATURATION,a);
		fclose(f);
		}

	UpdateData(false);
	Invalidate(false);
	UpdateWindow();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeresoDlg::OnButton1() 
{
	UpdateData();
	alldraw=false;
	visszaad(keres,DCOLOR);
	alldraw=true;
	Invalidate(false);
	UpdateWindow();
	return;
}

void CKeresoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
	UpdateData(false);
	DrawCamPic(&dc);
	for (int i=0;i<3;i++) dc.FillSolidRect(70+i*125,290,SCL,SCL,DCOLOR[i]);
	if(alldraw) {
		for (int k=0;k<3;k++){
				dc.MoveTo(keres[k]);
				dc.LineTo(keres[k].x+20,keres[k].y+20);
				dc.FillSolidRect(keres[k].x+20,keres[k].y+20,SCL,SCL,DCOLOR[k]);
		}
	}
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeresoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CKeresoDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	UpdateData();
	if (point.x>WI||point.y>HE) return;
	CDC* dc=GetDC();
	DCOLOR[m_Minta]=dc->GetPixel(point);
	Invalidate(false);
	UpdateWindow();
}

void CKeresoDlg::OnButton2()
{
	CDC *dc=GetDC();
	DrawCamPic(dc);
}

void CKeresoDlg::OnButton3() 
{
	m_log="";
	UpdateData(false);
}

void CKeresoDlg::visszaad(CPoint *&keres,long *&szin)
{
//	Invalidate(false);
//	UpdateWindow();
	unsigned long int *pdif;
	unsigned long int rval,gval,bval,rsz[3],gsz[3],bsz[3],dif,mindif;
	int i,j,k;
	for (i=0;i<3;i++){
		rsz[i]=(szin[i]&0x000000FF);
		gsz[i]=(szin[i]&0x0000FF00)>>8;
		bsz[i]=(szin[i]&0x00FF0000)>>16;
	}

	long col;
	CDC *dc=GetDC();
	DrawCamPic(dc);

//	CDC* dc=m_cVideo.GetDC();
	pdif=new unsigned long int[WI*HE*3];
	for (i=0;i<WI;i++){
		for (j=0;j<HE;j++){
			col=dc->GetPixel(i,j); 
			for (k=0;k<3;k++){
				rval=col&0x000000FF;
				gval=(col&0x0000FF00)>>8;
				bval=(col&0x00FF0000)>>16;
				pdif[k*WI*HE+j*WI+i]=sqrt((rsz[k]-rval)*(rsz[k]-rval)
									+(bsz[k]-bval)*(bsz[k]-bval)
									+(gsz[k]-gval)*(gsz[k]-gval));
			}
		}
	}

	for (k=0;k<3;k++){
		mindif=-1;
		for (i=d_s/2;i<WI-d_s/2;i++){
			for (j=d_s/2;j<HE-d_s/2;j++){
				dif=0;
				for (int i2=0;i2<d_s;i2++){
					for (int j2=0;j2<d_s;j2++){
						dif+=pdif[k*WI*HE+(j+j2-d_s/2)*WI+i+i2-d_s/2];
					}
				}
				if (dif<mindif){ keres[k].x=i; keres[k].y=j; mindif=dif;}
			}
		}
	}
	delete pdif;
}

CKeresoDlg::~CKeresoDlg()
{
//	fil.Close();
//	if (map!=0) delete []map;
	try
	{
		if (m_pVPBrick != NULL)
			m_pVPBrick->Close();
	}
	catch (const _com_error)
	{
		//ignore - closing anyway
	}
	delete[] keres;
	delete[] DCOLOR;
}


/********************************************************************************************/
int CKeresoDlg::execute(std::string command)
{
	if (m_pVPBrick == NULL)
		return -1;

	LONG nResult;

	try
	{
		if (m_pVPBrick->Status(LEGOVPBrickLib::GeneralStatus) != LEGOVPBrickLib::StatusReady)
		{
			MessageBox("Not ready", "Error");
			return -1;
		}

		m_pVPBrick->BrickType = m_pVPBrick->Status(LEGOVPBrickLib::CheckBrickType);

		if (m_pVPBrick->Status(LEGOVPBrickLib::BrickStatus) != LEGOVPBrickLib::StatusReady)
		{
			MessageBox("Brick not ready", "Error");
			return -1;
		}

		USES_CONVERSION;
		BSTR bstrCommand = SysAllocString(A2COLE(command.c_str()));
		LEGOVPBrickLib::CodeType nCodeType = LEGOVPBrickLib::MindScript;
//		LEGOVPBrickLib::CodeType nCodeType = LEGOVPBrickLib::LASM;
		LONG nErrPos;
		VARIANT vResult;
		VariantInit(&vResult);

		nResult = m_pVPBrick->Execute(&bstrCommand, &nCodeType, &nErrPos, &vResult);

		VariantClear(&vResult);

		SysFreeString(bstrCommand);
	}
	catch (const _com_error e)
	{
		MessageBox((LPCSTR)e.Description(), "Error!");
	}

	return nResult;
}

void CKeresoDlg::forward(void)
{
	execute("output A on 1 output C on 3 on [A C] forward [A C]");
}

void CKeresoDlg::reverse(void)
{
	execute("output A on 1 output C on 3 on [A C] backward [A C]");
}

void CKeresoDlg::stop(void)
{
	execute("output A on 1 output C on 3 off [A C]");
}

void CKeresoDlg::left(void)
{
	execute("output A on 1 output C on 3 on [A C] backward A forward C");
}

void CKeresoDlg::right(void)
{
	execute("output A on 1 output C on 3 on [A C] forward A backward C");
}

int CKeresoDlg::sensor(void)
{
	//return execute("sensor s on 2 s is switch as boolean get s");
	return execASM("poll 0,0");
}

void CKeresoDlg::send(int direction, int quantity)
{
	CString str,s1;
	switch (direction){
	case FWD:s1="elore mozditasa";
		break;
	case REV:s1="hatra mozditasa";
		break;
	case LEF:s1="balra forditasa";
		break;
	case RIG:s1="jobbra forditasa";
		break;
	}
	str.Format("Kocsi "+s1+" %d egyseggel",quantity);
	AddLog(str);
	int code = 0x80 | direction | ((quantity >> 6) & 0xF);
	std::string msg = "send ";
	char num[10];
	_itoa(code, num, 10);
	msg += num;
	//AddLog(msg.c_str());
	while (sensor()==1);
	execute(msg);
	msg="send ";
	code=0x40 | (quantity & 0x7F);
	_itoa(code, num, 10);
	msg += num;
	//AddLog(msg.c_str());
	execute(msg);
	while (sensor()==1);
	AddLog("Muvelet befejezve!");
}

int CKeresoDlg::execASM(std::string command)
{
	if (m_pVPBrick == NULL)
		return -1;

	LONG nResult;

	try
	{
		if (m_pVPBrick->Status(LEGOVPBrickLib::GeneralStatus) != LEGOVPBrickLib::StatusReady)
		{
			MessageBox("Not ready", "Error");
			return -1;
		}

		m_pVPBrick->BrickType = m_pVPBrick->Status(LEGOVPBrickLib::CheckBrickType);

		if (m_pVPBrick->Status(LEGOVPBrickLib::BrickStatus) != LEGOVPBrickLib::StatusReady)
		{
			MessageBox("Brick not ready", "Error");
			return -1;
		}

		USES_CONVERSION;
		BSTR bstrCommand = SysAllocString(A2COLE(command.c_str()));
//		LEGOVPBrickLib::CodeType nCodeType = LEGOVPBrickLib::MindScript;
		LEGOVPBrickLib::CodeType nCodeType = LEGOVPBrickLib::LASM;
		LONG nErrPos;
		VARIANT vResult;
		VariantInit(&vResult);

		nResult = m_pVPBrick->Execute(&bstrCommand, &nCodeType, &nErrPos, &vResult);

		VariantClear(&vResult);

		SysFreeString(bstrCommand);
	}
	catch (const _com_error e)
	{
		MessageBox((LPCSTR)e.Description(), "Error!");
	}

	return nResult;
}

void CKeresoDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	visszaad(keres,DCOLOR);
	CString str;
	float turn,move,dest_angle;
	CPoint cp;
	cp=GetPosition(keres[0],keres[1]);
	car_x=cp.x;
	car_y=cp.y;
	dest_x=keres[2].x;
	dest_y=keres[2].y;
	car_angle=GetAngle(keres[0],keres[1]);
	dest_angle=atan2(dest_y-car_y,dest_x-car_x)*180/PI;
	turn=dest_angle-car_angle;
	str.Format("A kocsi iranya %f, tole a cel %f-re van, tehat %f-t kell fordulnia",car_angle,dest_angle,turn);
	AddLog(str);
	move=sqrt((dest_x-car_x)*(dest_x-car_x)+(dest_y-car_y)*(dest_y-car_y));
	str.Format("A kocsi pozicioja: %d,%d ; a cel pozicioja: %d,%d!",car_x,car_y,dest_x,dest_y);
	AddLog(str);
	str.Format("A kocsi es a cel tavolsaga %f pixel",move);
	AddLog(str);
	if (turn<0) send(RIG,abs(turn/turn_val)); else send(LEF,abs(turn/turn_val));
	send(FWD,move/move_val);
//	if (sensor()) AddLog("Pressed..."); else AddLog("Unpressed...");
	//draw_map();
}

void CKeresoDlg::OnAskcam() 
{
	// TODO: Add your control notification handler code here
	visszaad(keres,DCOLOR);
	car_x=keres[0].x;
	car_y=keres[0].y;
	car_angle=0;//dlg.m_carangle;
	dest_x=keres[2].x;
	dest_y=keres[2].y;
	CString str;
	str.Format("Car position updated to %d,%d angle setted to %d!",car_x,car_y,car_angle);
	AddLog(str);
	str.Format("Destination position updated to %d,%d!",dest_x,dest_y);
	AddLog(str);
}

void CKeresoDlg::AddLog(CString str)
{
  UpdateData();
  m_log+=str;
  m_log+=endl;
  UpdateData(false);
}

void CKeresoDlg::OnMovecal() 
{
	// TODO: Add your control notification handler code here
//	if (map!=0) delete []map;
	CString str;
	CPoint *keres_t,move;
	keres_t=new CPoint[3];

//fordulas kalibralasa
	visszaad(keres,DCOLOR);
	turn_val=GetAngle(keres[0],keres[1]);
	
	str.Format("A kocsi elejenek koordinatai: %d,%d hatuljanak: %d,%d iranya: %f!",keres[0].x,keres[0].y,keres[1].x,keres[1].y,turn_val);
	AddLog(str);

	send(LEF,32);
	visszaad(keres_t,DCOLOR);
	turn_val=(GetAngle(keres_t[0],keres_t[1])-turn_val)/32;
	if (turn_val<0)turn_val=-turn_val;

	str.Format("Fordulas utan elejenek koordinatai: %d,%d hatuljanak: %d,%d iranyavaltozas: %f!",keres_t[0].x,keres_t[0].y,keres_t[1].x,keres_t[1].y,turn_val);
	AddLog(str);

//haladas kalibralasa

	send(FWD,32);
	visszaad(keres,DCOLOR);
	move=GetPosition(keres[0],keres[1])-GetPosition(keres_t[0],keres_t[1]);
	move_val=sqrt(move.x*move.x+move.y*move.y)/32;

	str.Format("Elore utan elejenek koordinatai: %d,%d hatuljanak: %d,%d haladas: %f!",keres[0].x,keres[0].y,keres[1].x,keres[1].y,move_val);
	AddLog(str);
/*	CPoint cs;
	cs=keres[0]-keres[1];
	car_size=sqrt(cs.x*cs.x+cs.y*cs.y);
	MAP_X_SIZE=WI/car_size;
	MAP_Y_SIZE=HE/car_size;

	str.Format("A kocsi merete %d pixel, a terkep merete %dx%d!",car_size,MAP_X_SIZE,MAP_Y_SIZE);
	AddLog(str);
	
	map=new bool[MAP_X_SIZE*MAP_Y_SIZE];
	for (int i=0;i<MAP_Y_SIZE;++i)
	{
		for (int j=0;j<MAP_X_SIZE;++j){
			map[i*MAP_X_SIZE+j]=false;
		}
	}*/

	delete[] keres_t;
}

float CKeresoDlg::GetAngle(CPoint eleje, CPoint hatulja)
{
	return -atan2(eleje.y-hatulja.y,eleje.x-hatulja.x)*180/PI;
}

CPoint CKeresoDlg::GetPosition(CPoint eleje, CPoint hatulja)
{
	CPoint cp;
	cp.x=(eleje.x+hatulja.x)/2;
	cp.y=(eleje.y+hatulja.y)/2;
	return (cp);
}


BOOL CKeresoDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	FILE *f;
	long a;
	char aa;
	f=fopen("camerasett.dat","wb");
	if (f!=NULL) 
		{
		m_cVideo.GetCameraPropertyLong(PROPERTY_BRIGHTNESS,&a);
		aa=a;
		fputc(aa,f);
		m_cVideo.GetCameraPropertyLong(PROPERTY_CONTRAST,&a);
		aa=a;
		fputc(aa,f);
		m_cVideo.GetCameraPropertyLong(PROPERTY_SATURATION,&a);
		aa=a;
		fputc(aa,f);
		fclose(f);
		}
	
	return CDialog::DestroyWindow();
}

/*void CKeresoDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	send(FWD,10);
	if (2 == sensor()) AddLog("Pressed..."); else AddLog("Unpressed...");

}

void CKeresoDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	send(REV,10);
	if (2==sensor()) AddLog("Pressed..."); else AddLog("Unpressed...");

}

void CKeresoDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	send(LEF,10);
	if (2==sensor()) AddLog("Pressed..."); else AddLog("Unpressed...");

}

void CKeresoDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	send(RIG,10);
	if (2==sensor()) AddLog("Pressed..."); else AddLog("Unpressed...");
	
}*/

void CKeresoDlg::OnPos() 
{
	// TODO: Add your control notification handler code here
	CString str;
	visszaad(keres,DCOLOR);
	float turn_val=GetAngle(keres[0],keres[1]);
	
	str.Format("A kocsi elejenek koordinatai: %d,%d hatuljanak: %d,%d iranya: %f!",keres[0].x,keres[0].y,keres[1].x,keres[1].y,turn_val);
	AddLog(str);
}

BEGIN_EVENTSINK_MAP(CKeresoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CKeresoDlg)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CKeresoDlg::DrawCamPic(CDC *dc)
{
	kepdc=m_cVideo.GetDC();
	dc->BitBlt(0,0,320,240,kepdc,0,0,SRCCOPY);

}

void CKeresoDlg::OnKeziKalib() 
{
	// TODO: Add your control notification handler code here
	CManualCalibDlg dlg;
	dlg.m_turn_val=turn_val;
	dlg.m_move_val=move_val;
	if (dlg.DoModal()==IDOK){
		turn_val=dlg.m_turn_val;
		move_val=dlg.m_move_val;
	}
}
