// keresoDlg.h : header file
//
//{{AFX_INCLUDES()
#include "videoportal.h"
//}}AFX_INCLUDES

#if !defined(AFX_KERESODLG_H__1AB5A222_15C8_45B1_96E6_ECD2C05A1C7D__INCLUDED_)
#define AFX_KERESODLG_H__1AB5A222_15C8_45B1_96E6_ECD2C05A1C7D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CKeresoDlg dialog
#include "LVServerDefs.H"
#include <string>
#include <math.h>
#include <atlconv.h>
#include "ManualCalibDlg.h"

#import "vpbcom.tlb"

#define FWD 0x20
#define REV 0x30
#define LEF 0x10
#define RIG 0x00
#define PI 3.1415926

class CKeresoDlg : public CDialog
{
// Construction
private:
	LEGOVPBrickLib::IVPBrickPtr m_pVPBrick;
/*	int MAP_X_SIZE;
	int MAP_Y_SIZE;
	int car_size;*/

public:
	CPoint GetPosition(CPoint eleje, CPoint hatulja);
	float GetAngle(CPoint eleje,CPoint hatulja);
	float turn_val;//1 egysegnyi fordulas fokban 
	float move_val;//1 egysegnyi elore haladas pixelben
	~CKeresoDlg();
	int execute(std::string command);
	void forward(void);
	void reverse(void);
	void stop(void);
	void left(void);
	void right(void);
	int sensor(void);
	void send(int direction, int quantity);
	int execASM(std::string command);
	bool alldraw;
	int car_x;
	int car_y;
	float car_angle;
	int dest_x;
	int dest_y;
//	void OnResetmap();
	void OnAskcam();
	CKeresoDlg(CWnd* pParent = NULL);	// standard constructor
	CBitmap kep;
	CDC* kepdc;
	long *DCOLOR;
	CPoint *keres;
	int w,h;
// Dialog Data
	//{{AFX_DATA(CKeresoDlg)
	enum { IDD = IDD_KERESO_DIALOG };
	CVideoPortal	m_cVideo;
	int		m_Minta;
	CString	m_log;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeresoDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void DrawCamPic(CDC *dc);
	void visszaad(CPoint *&keres,long *&szin);
	void AddLog(CString str);
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CKeresoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnButton1();
	afx_msg void OnStart();
	afx_msg void OnMovecal();
	afx_msg void OnButton6();
	afx_msg void OnButton7();
	afx_msg void OnButton8();
	afx_msg void OnButton9();
	afx_msg void OnPos();
	afx_msg void OnKeziKalib();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KERESODLG_H__1AB5A222_15C8_45B1_96E6_ECD2C05A1C7D__INCLUDED_)
